<?php
/**
 * MessagesQuery
 *
 * PHP version 5
 *
 * @category Class
 * @package  Fifa\ConnectServiceBus\Sdk\Api
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * FIFA Connect Service Bus - V3
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Fifa\ConnectServiceBus\Sdk\Api\Model;

use \ArrayAccess;

/**
 * MessagesQuery Class Doc Comment
 *
 * @category    Class
 * @package     Fifa\ConnectServiceBus\Sdk\Api
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class MessagesQuery implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'MessagesQuery';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'number_of_items' => 'int',
        'queue_identifier' => 'string'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'number_of_items' => 'numberOfItems',
        'queue_identifier' => 'queueIdentifier'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'number_of_items' => 'setNumberOfItems',
        'queue_identifier' => 'setQueueIdentifier'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'number_of_items' => 'getNumberOfItems',
        'queue_identifier' => 'getQueueIdentifier'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['number_of_items'] = isset($data['number_of_items']) ? $data['number_of_items'] : null;
        $this->container['queue_identifier'] = isset($data['queue_identifier']) ? $data['queue_identifier'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['number_of_items'] === null) {
            $invalid_properties[] = "'number_of_items' can't be null";
        }
        if (($this->container['number_of_items'] > 50)) {
            $invalid_properties[] = "invalid value for 'number_of_items', must be smaller than or equal to 50.";
        }

        if (($this->container['number_of_items'] < 1)) {
            $invalid_properties[] = "invalid value for 'number_of_items', must be bigger than or equal to 1.";
        }

        if ($this->container['queue_identifier'] === null) {
            $invalid_properties[] = "'queue_identifier' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['number_of_items'] === null) {
            return false;
        }
        if ($this->container['number_of_items'] > 50) {
            return false;
        }
        if ($this->container['number_of_items'] < 1) {
            return false;
        }
        if ($this->container['queue_identifier'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets number_of_items
     * @return int
     */
    public function getNumberOfItems()
    {
        return $this->container['number_of_items'];
    }

    /**
     * Sets number_of_items
     * @param int $number_of_items
     * @return $this
     */
    public function setNumberOfItems($number_of_items)
    {

        if (($number_of_items > 50)) {
            throw new \InvalidArgumentException('invalid value for $number_of_items when calling MessagesQuery., must be smaller than or equal to 50.');
        }
        if (($number_of_items < 1)) {
            throw new \InvalidArgumentException('invalid value for $number_of_items when calling MessagesQuery., must be bigger than or equal to 1.');
        }

        $this->container['number_of_items'] = $number_of_items;

        return $this;
    }

    /**
     * Gets queue_identifier
     * @return string
     */
    public function getQueueIdentifier()
    {
        return $this->container['queue_identifier'];
    }

    /**
     * Sets queue_identifier
     * @param string $queue_identifier
     * @return $this
     */
    public function setQueueIdentifier($queue_identifier)
    {
        $this->container['queue_identifier'] = $queue_identifier;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::sanitizeForSerialization($this));
    }
}


